# Hands-On Functional Programming in Rust
This is the code repository for [Hands-On Functional Programming in Rust](https://www.packtpub.com/application-development/hands-functional-programming-rust?utm_source=github&utm_medium=repository&utm_campaign=9781788839358), published by [Packt](https://www.packtpub.com/?utm_source=github). It contains all the supporting project files necessary to work through the book from start to finish.
## About the Book
Functional Programming allows developers to divide programs into smaller, reusable components that ease the creation, testing, and maintenance of software as a whole. Combined with the power of Rust, you can develop robust and scalable applications that fulfill modern day software requirements. This book will help you discover all the Rust features that can be used to build software in a functional way.
## Instructions and Navigation
All of the code is organized into folders. Each folder starts with a number followed by the application name. For example, Chapter02.

All code files are present in their respective folders.

The code will look like the following:
```
pub trait MotorController
{
  fn init(&mut self, esp: ElevatorSpecification, est: ElevatorState);
  fn poll(&mut self, est: ElevatorState, dst: u64) -> MotorInput;
}
```

In order to successfully read through this book and work out all the code samples, we expect readers to fulfill the following
* We assume familiarity with the concepts from the first 10 chapters of Rust
documentation (https:/​/​doc.​rust-​lang.​org/​book/​). Some of the material from
these chapters is fairly advanced, so we will also explain that here when relevant.
However, the knowledge of syntax and very basic features will be expected.
* Clone the GitHub code repository and follow along. Tweak the examples and see
what effects you can create.
* Stay curious. Some of the keywords we mentioned could fill an entire book with
unique content. Some of these topics presented are so pervasive that they have
decent Wikipedia articles to explain and expand on the concepts. However,
knowing the keyword is required to even know what to search for.

## Related Products
* [Rust Programming By Example](https://www.packtpub.com/application-development/rust-programming-example?utm_source=github&utm_medium=repository&utm_campaign=9781788390637)

* [Mastering Rust](https://www.packtpub.com/application-development/mastering-rust?utm_source=github&utm_medium=repository&utm_campaign=9781785885303)

* [Rust Cookbook](https://www.packtpub.com/application-development/rust-cookbook?utm_source=github&utm_medium=repository&utm_campaign=9781785880254)


